//   

function FillQuestionSet()
{
  var NQ=0;
  //       QuestionSet
  for(i=0;i<ask.length;i++)
  {
    NQ+=ask[i];
  };
  //      
  QuestionSet=new Array(NQ);
  i=0; //      QuestionSet
  //   
  for(j=0;j<divisions.length;j++)
  {
    if(divisions[j]<ask[j])ask[j]=divisions[j];  //    ,       
    var FA=new Array(divisions[j])	    //     
    for(n=0;n<FA.length;n++)FA[n]=0;
    //    ,   
    for(k=0;k<ask[j];k++)
    {
      do
      {
        //  
        m=Math.floor(Math.random()*divisions[j]);
      }while(FA[m]!=0);
      FA[m]=1;				    //        
      QuestionSet[i]=Q[j][m];
      i++;
    }
  }
}

function StartTest()
{
  FillQuestionSet();
  for(i=0;i<QuestionSet.length;i++)
  {
    showExercise(QuestionSet[i]);
  }
  LockUI=false;
  ShowTesting();  
}

function getExercise(ExH)
{
  return document.getElementById("d"+ExH[0]+"q"+ExH[1]);
}

function showExercise(ExH)
{
  getExercise(ExH).style.display="block";
}

function hideExercise(ExH)
{
  getExercise(ExH).style.display="none";
}

function getAnswerButton(ExH, answer)
{
  return document.getElementById("d"+ExH[0]+"q"+ExH[1]+"b"+answer);
}

function getAnswerTxt(ExH, answer)
{
  return document.getElementById("d"+ExH[0]+"q"+ExH[1]+"a"+answer);
}


//  0=  ; -1=  ; 1=  .
//  .     unselectAll().

function getAnswerStatus(ExH)
{
  var count=ExH[2].length;
  var ans
  var error=false;
  var ansCount=0;
  
  for(ans=0;ans<count;ans++)
  {
    button=getAnswerButton(ExH,ans);
    if(button.checked != (ExH[2][ans]==1)) error=true;
    if(button.checked) ansCount++;
    button.disabled=1;
  }
  if(ansCount==0) return -1;
  if(error){ return 1; }else{ return 0; }
}

//   
function hilightErrors()
{
  var i;
  for(i=0; i<QuestionSet.length; i++)
  {
    //  
    exStyle=getExercise(QuestionSet[i]).style
    exStyle.borderWidth="2px";
    exStyle.borderStyle="solid";
    if(Errors[i])
    {
      exStyle.borderColor="red";
    }
    else
    {
      exStyle.borderColor="#00A900";
    }
    //   
    var count=QuestionSet[i][2].length;
    for(j=0; j<count; j++)
    {
      if(QuestionSet[i][2][j]==1) getAnswerTxt(QuestionSet[i],j).style.color="#007000";
    }
  }
}

function unHiligthErrors()
{
  var i;
  for(i=0; i<QuestionSet.length; i++)
  {
    getExercise(QuestionSet[i]).style.borderStyle="none";
    
    var count=QuestionSet[i][2].length;
    for(j=0; j<count; j++)
    {
      if(QuestionSet[i][2][j]==1) getAnswerTxt(QuestionSet[i],j).style.color="black";
    }
  }
}

function unselectAll()
{
  var i;
  for(i=0; i<QuestionSet.length; i++)
  {
    var ExH=QuestionSet[i];
    var count=ExH[2].length;
    for(j=0; j<count; j++)
    {
      button=getAnswerButton(ExH,j);
      button.disabled=0;
      button.checked=false;
    }
  }
}

function finishTest()
{
  document.getElementById("resaultbutton").style.display="none";
  //    
  var correct=0;
  var wrong=0;
  var skipped=0;
  var status;
  
  Errors=new Array(QuestionSet.length);
 
  //   
  for(i=0;i<QuestionSet.length;i++)
  {
    status=getAnswerStatus(QuestionSet[i])
    if(status!=-1)  //   
    {
      if(status==0)
      {
        correct++;
        Errors[i]=false;
      }
      else
      {
        wrong++;
        Errors[i]=true;
      }
    }
    else
    {
      skipped++;
      Errors[i]=true;
    }
  }
  
  //  
  
  document.getElementById("RWrong").innerHTML=wrong;
  document.getElementById("RCorrect").innerHTML=correct;
  document.getElementById("RSkipped").innerHTML=skipped;
  document.getElementById("RMark").innerHTML=getTextMark(correct);
  
  hilightErrors();
    
  ShowResault();
}

function getTextMark(num)
{
  if(num>=85) return "";
  if(num>=79) return "";
  if(num>=51) return "";
  return "";
}

function cleanupExam()
{
  //   
  unHiligthErrors();
  //        enabled
  unselectAll();
  //   
  for(i=0;i<QuestionSet.length;i++)
  {
    hideExercise(QuestionSet[i]);
  }
  //   "  "
  document.getElementById("ShowErrorsOnly").checked=false;
}

function ShowWaitLoading()
{
  document.getElementById("testtitle").style.display="none";
  document.getElementById("waitload").style.display="block";
  document.getElementById("main").style.display="none";
  document.getElementById("resault").style.display="none";
  document.getElementById("resaultbutton").style.display="none";
  document.getElementById("waitresault").style.display="none";
  document.getElementById("waitrestart").style.display="none";
}

function ShowTesting()
{
  document.getElementById("testtitle").style.display="block";
  document.getElementById("waitload").style.display="none";
  document.getElementById("main").style.display="block";
  document.getElementById("resault").style.display="none";
  document.getElementById("resaultbutton").style.display="block";
  document.getElementById("waitresault").style.display="none";
  document.getElementById("waitrestart").style.display="none";
  window.location.href="#Start";
}

function ShowCalculating()
{
  document.getElementById("testtitle").style.display="none";
  document.getElementById("waitload").style.display="none";
  document.getElementById("main").style.display="none";
  document.getElementById("resault").style.display="none";
  document.getElementById("resaultbutton").style.display="none";
  document.getElementById("waitresault").style.display="block";
  document.getElementById("waitrestart").style.display="none";
  window.location.href="#WRes";
}

function ShowResault()
{
  document.getElementById("testtitle").style.display="block";
  document.getElementById("waitload").style.display="none";
  document.getElementById("main").style.display="block";
  document.getElementById("resault").style.display="block";
  document.getElementById("resaultbutton").style.display="none";
  document.getElementById("waitresault").style.display="none";
  document.getElementById("waitrestart").style.display="none";
  window.location.href="#resault-ancor";
}

function ShowRestarting()
{
  document.getElementById("testtitle").style.display="none";
  document.getElementById("waitload").style.display="none";
  document.getElementById("main").style.display="none";
  document.getElementById("resault").style.display="none";
  document.getElementById("resaultbutton").style.display="none";
  document.getElementById("waitresault").style.display="none";
  document.getElementById("waitrestart").style.display="block";
  window.location.href="#WNew";
}

function ShowErr()
{
  var i;
  if(document.getElementById("ShowErrorsOnly").checked)
  {
    for(i=0; i<Errors.length; i++)
    {
      if(!Errors[i])
      {
        hideExercise(QuestionSet[i]);
      }
    }
  }
  else
  {
    for(i=0; i<QuestionSet.length; i++)
    {
      showExercise(QuestionSet[i]);
    }
  }
  document.getElementById("ShowErrorsOnly").disabled=0;
  window.location.href="#resault-ancor";
}